function [G,t] = cholesky_gaxpy(A)
    n = size(A,1);
    
    % eigentliche Berechnung
    tic;
    A(1:n,1) = A(1:n,1) / sqrt(A(1,1));
    for j=2:n
        A(j:n,j) = A(j:n,j) - A(j:n,1:j-1) * A(j,1:j-1)'; % GAXPY-Operation
        A(j:n,j) = A(j:n,j) / sqrt(A(j,j));
    end
    t = toc;
    
    % Rückgabewert erzeugen
    G = zeros(n,n);
    for k = 1:n
        G(k:n,k) = A(k:n,k);
    end
end