
function [] = test()
    values = [9,25,64,100,196, 400, 900];
    test2(5:5:30, 'pascal        ', @pascal);
    test2(values, 'gcdmat        ', @gcdmat);
    test2(values, 'poisson sparse', @poisson_sparse);
    test2(values, 'poisson full  ', @poisson_full);
    test2(values, 'moler         ', @moler);
    test2(values, 'randcorr      ', @randcorr);
end

function [A] = gcdmat(k);         A = gallery('gcdmat', k); end
function [A] = poisson_sparse(k); A = gallery('poisson', sqrt(k)); end
function [A] = poisson_full(k);   A = full(poisson_sparse(k)); end
function [A] = moler(k);          A = gallery('moler', k); end
function [A] = randcorr(k);       A = gallery('randcorr', k); end % semidefinite

function [] = test2(values, name, func)
    %r = zeros(30,2);
    %for k=1:30
    %    [r(k,1),r(k,2)] = run(pascal(k));
    %end
    %r
    fprintf(1, '\n');
    fprintf(1, '%-14s  %4s  %s  %s  %s  %s  %s\n', 'name', 'n', ...
               'outer-prod sec', 'gaxpy sec', 'matlab sec', ...
               ' norm(err0)', ' norm(err1)');
    for k=values
        A = func(k);
        [t0,t1,t2,n0,n1] = run(A);
        fprintf(1, '%s  %4d  %14.4f  %9.4f  %10.4f  %11g  %11g\n', ...
                name, size(A,1), t0, t1, t2, n0, n1);
    end
end

function [t0,t1,t2,n0,n1] = run(A)
    [G0,t0] = cholesky(A);
    [G1,t1] = cholesky_gaxpy(A);
    tic;
    G2 = chol(A);
    t2 = toc;
    n0 = norm(G0' - G2);
    n1 = norm(G1' - G2);
end
